<?
// SonnenInfo
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// nderungen sind nur hier ntig

// Lnge und Breite im angegebenen Format (Dezimalformat, aus Google Maps)
// Beispiel Brandenburger Tor: Aufrufen in Google Maps, Doppelklick drauf zum zentrieren. Oben rechts im Fenster "Link" anklicken, die darunter erscheinende URL kopieren und analysieren. Sieht so aus:
//http://maps.google.de/maps?f=q&hl=de&q=Brandenburger+Tor,+Pariser+Platz,+Mitte+10117+Berlin,+Berlin,+Berlin&sll=51.151786,10.415039&sspn=13.246778,26.938477&ie=UTF8&cd=5&geocode=Fa1VIQMd8iDMAA&ll=52.516262,13.377691&spn=0.000196,0.000411&t=k&z=21

// die Zahlen hinter reichstag&sll= sind die Koordinaten: 52.516262 (nrliche Breite) , 13.377691 (stliche Lnge)
// wer sdlich der quators wohnt und westlich vom Nullmeridian mu entsprechend ein - (Minus) voranstellen. Das habe ich aber nicht getestet.


$lat = 52.516262; 
$long = 13.377691;

$gmtoff = 1;

// Offsetwinkel: wohin zeigt die Nordseite des Hauses? (+10 = Nordseite zeigt nach 350 , -10 = Nordseite zeigt nach 10)
$offsetwinkel = 10;

// Schriftendefinition: es werden nur diese beiden Schriften verwendet. Bei anderen Schriften darauf achten, dass die Digischrift das  (Grad) darstellen kann
$fontpath='c:/WINDOWS/fonts/';
$schrift = $fontpath. 'arial.ttf';
$digischrift = $fontpath. 'digiface regular.ttf'; // einfach nach digiface regular googeln, ist frei erhltlich

// bmp ermglichen
include("bmp.php");
// Name des Grafik-files, bmp als Endung wird automatisch drangehngt.
// Es sind auch andere Formate mglich (solange php sie erstellen kann), dafr mu am Ende die Grafikausgabe angepat werden
$file = "SunInfo";

// Gre der Grafik:
// es wird nur die Zeigerlnge fr die Kompassanzeige angegeben, alles anderen Mae beziehen sich darauf, Schriftengren allerdings nicht
// Angabe in Pixeln. Die Grafik ist dann doppelt so breit und 2,5 mal so hoch wie die $laenge
// sinnvoll ist 50 bis 100
$laenge = 66;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ab hier nichts mehr ndern....

// Zeiten fr "Maximalwerte, also Sommer und Wintersonnwende
$datearray[0] = strtotime ("21 june ".date("Y"));
$datearray[1] = strtotime (date("Y-m-d"));
$datearray[2] = strtotime ("21 december ".date("Y"));

$i = 0; 
$z = 0;

foreach  ($datearray as $datum) 
{
//echo date("Y-m-d" , $datum)."\n";
$sun_info = date_sun_info($datum, $lat, $long);
foreach ($sun_info as $key => $val) 
	{
	// Uhrzeiten der Sonnendaten in Array schreiben
	$schluessel[$i] = $key;
	$value[$z][$i] = date("H:i:s", $val);
	//echo date("Y-m-d  H:i:s" , $val)." val\n";
	//---------------------------------------------------------------------------------------------------
	// Winkel berechnen und speichern
	  //
      //GB: geographische Breite
      $GB = $lat;

      //GBB: geographische Breite im Bogenma
      $GBB = $GB*M_PI/180;

      //GL: geographische Lnge
      $GL = $long;

      //GM: Meridian (geographische Lnge), auf dem die rtliche Standardzeit beruht
      $GM = 15.0; //15 fr MEZ

      //N: Nummer des Tages im Jahr
      $N = date("z" , $val);

      //Standardzeit (Ohne Sommerzeit)!
      $SZ = date("G" , $val) + date("i" , $val)/60 - date("I" , $val);

      //B: Jahreskorrekturwinkel
      $B = ($N-1) * 2*M_PI/365;

      //E: Zeitgleichung (Strungen durch Erdumlauf und Erdrotation)
      $E = 229.2 * (0.000075 + 0.001868 * cos($B) - 0.032077 * sin($B) - 0.014615 * cos(2*$B) - 0.04089 * sin(2*$B)) / 60;

      //TS: Sonnenzeit
      $TS = $SZ + $E + 4*($GL - $GM) / 60;
      $ts = 12.0 - $TS;

      //SzW: Stundenwinkel
      $SzW = $ts * M_PI/12;

      //Dekl: Deklination
      $Dekl = (23.45 * M_PI/180) * sin(2*M_PI * (284 + $N) / 365.25);

      //ShW: Sonnen-Hhenwinkel
      $ShW = asin(sin($GBB) * sin($Dekl) + cos($GBB) * cos($Dekl) * cos($SzW));

      //AzW: Azimutwinkel der Horizontale in GRAD
      $AzW = acos(((sin($GBB) * sin($ShW)) - sin($Dekl)) / (cos($GBB) * cos($ShW))) * 180/M_PI;

      if ($ts < 0) $AzW = -$AzW;

      $Hoehenwinkel[$z][$i] = round( $ShW * 180/M_PI );
      $Himmelsrichtung[$z][$i] = round( 180 - $AzW );

      //echo "GB:$GB<<GBB:$GBB<<GL:$GL<<GM:$GM<<N:$N<<SZ.$SZ<<B:$B<<E:$E<<TS:$TS<<ts:$ts<<";
      //echo "SzW:$SzW<<Dekl:$Dekl<<ShW:".$ShW*180/M_PI."<<AzW:$AzW";

	//---------------------------------------------------------------------------------------------------
   //echo "\nkey: " . date("H:i:s", $val) . "\n";
   //echo "Hhe: ".$Hoehenwinkel[$z][$i]." Azim: ".$Himmelsrichtung[$z][$i]."\n";
	$i++;
	}
	$i=0;
$z++;
}

// Sonnenwinkel fr JETZT berechnen
{

 $val = time();
	//---------------------------------------------------------------------------------------------------
	// Winkel berechnen und speichern
	  //
      //GB: geographische Breite
      $GB = $lat;

      //GBB: geographische Breite im Bogenma
      $GBB = $GB*M_PI/180;

      //GL: geographische Lnge
      $GL = $long;

      //GM: Meridian (geographische Lnge), auf dem die rtliche Standardzeit beruht
      $GM = 15.0; //15 fr MEZ

      //N: Nummer des Tages im Jahr
      $N = date("z" , $val);

      //Standardzeit (Ohne Sommerzeit)!
      $SZ = date("G" , $val) + date("i" , $val)/60 - date("I" , $val);

      //B: Jahreskorrekturwinkel
      $B = ($N-1) * 2*M_PI/365;

      //E: Zeitgleichung (Strungen durch Erdumlauf und Erdrotation)
      $E = 229.2 * (0.000075 + 0.001868 * cos($B) - 0.032077 * sin($B) - 0.014615 * cos(2*$B) - 0.04089 * sin(2*$B)) / 60;

      //TS: Sonnenzeit
      $TS = $SZ + $E + 4*($GL - $GM) / 60;
      $ts = 12.0 - $TS;

      //SzW: Stundenwinkel
      $SzW = $ts * M_PI/12;

      //Dekl: Deklination
      $Dekl = (23.45 * M_PI/180) * sin(2*M_PI * (284 + $N) / 365.25);

      //ShW: Sonnen-Hhenwinkel
      $ShW = asin(sin($GBB) * sin($Dekl) + cos($GBB) * cos($Dekl) * cos($SzW));

      //AzW: Azimutwinkel der Horizontale in GRAD
      $AzW = acos(((sin($GBB) * sin($ShW)) - sin($Dekl)) / (cos($GBB) * cos($ShW))) * 180/M_PI;

      if ($ts < 0) $AzW = -$AzW;

      $JetztHoehenwinkel = round( $ShW * 180/M_PI );
      $JetztHimmelsrichtung = round( 180 - $AzW );
}
// $winkel ist Himmelsrichtung, +90 um die Anzeige anzupassen (0 = West statt Nord)
$winkel = $JetztHimmelsrichtung + 90;

// Grafik erzeugen

$top = $laenge / 2;
$breite = 2 * $laenge;
$hoehe = 2 * $laenge + $top;
$centx = $laenge;
$centy = $laenge + $top; 

$im = @ImageCreatetruecolor ($breite, $hoehe);


// Farben + Schriften
{
$background = ImageColorAllocate ($im, 236, 233, 216); // hellgrauer Hintergrund wie StudioAnzeigen
$skalafarbe = ImageColorAllocate ($im, 128, 128, 128); // Skalafarbe fr Kreisbogen und Unit
$rot = ImageColorAllocate ($im, 204, 64, 64);
$hellrot = ImageColorAllocate ($im, 255, 0, 0);
$gruen = ImageColorAllocate ($im, 0, 150, 0);
$hellgruen = ImageColorAllocate ($im, 0, 255, 0);
$orange = ImageColorAllocate ($im, 255, 192, 0);
$hellorange = ImageColorAllocate ($im, 255, 255, 0);
$blau = ImageColorAllocate ($im, 0, 0, 204);
$hellblau = ImageColorAllocate ($im, 1, 1, 255);
$dunkelblau = ImageColorAllocate ($im, 50, 50, 200);
$kreis = ImageColorAllocate ($im, 236, 233, 216);
$gelb = ImageColorAllocate ($im, 255, 255, 0);
$alphagelb = imagecolorallocatealpha($im, 255, 255, 0 , 64);
$grau = ImageColorAllocate ($im, 83, 80, 77);
$dunkelgrau = ImageColorAllocate ($im, 32, 32, 32);
$hellgrau = ImageColorAllocate ($im, 160, 160, 160 );
// durchsichtiges grau fr Hhenanzeige
$alphagrau = imagecolorallocatealpha ( $im , 90, 90, 90, 50 );
$backgroundalpha = imagecolorallocatealpha ( $im , 236, 233, 216, 18 );
$schwarz = ImageColorAllocate ($im, 0, 0, 0);
// Zeigerfarbe abhngig ob Sonne aufgegangen
if ($JetztHoehenwinkel < 0 )
	{
	$zeigerfarbe = $alphagelb;
	} else {
	$zeigerfarbe = $gelb;
	}


}
imagefill( $im, 0 , 0 , $background );



// kreisbogen 360 als Skala
imageantialias ( $im, 1 );
imagesetthickness ( $im , 2 );
imagearc ( $im, $centx, $centy, (2*$laenge)-8, (2*$laenge)-8, 330, 240 , $skalafarbe );
imageantialias ( $im, 0 );
imagesetthickness ( $im , 1 );
//$skalafarbe = ImageColorAllocate ($im, 64, 64, 64);
//imagearc ( $im, $centx, $centy, $bkreis-6, $hkreis-6, 180, 0, $skalafarbe );

// Bgen fr Sonnenzeiten zeichnen. Es werden FilledArcs gemalt, spter in der Mitte ein gefllter Kreis drber.
{
// Kreis fr "Nacht" in dunkelblau
imagefilledellipse ( $im, $centx, $centy, (2*$laenge)-10, (2*$laenge)-10, $schwarz );
// Bogen fr Sommer
imagefilledarc ( $im, $centx, $centy, (2*$laenge)-10, (2*$laenge)-10, $Himmelsrichtung[0][0] + 270+$offsetwinkel, $Himmelsrichtung[0][1] +270+$offsetwinkel , $dunkelblau , IMG_ARC_PIE );
// Bogen fr Dmmerung heute
imagefilledarc ( $im, $centx, $centy, (2*$laenge)-10, (2*$laenge)-10, $Himmelsrichtung[1][3] + 270+$offsetwinkel, $Himmelsrichtung[1][4] +270+$offsetwinkel , $alphagelb , IMG_ARC_PIE );
// Bogen fr Heute
imagefilledarc ( $im, $centx, $centy, (2*$laenge)-10, (2*$laenge)-10, $Himmelsrichtung[1][0] + 270+$offsetwinkel, $Himmelsrichtung[1][1] +270+$offsetwinkel , $gelb , IMG_ARC_PIE );
// Bogen fr Winter
imagefilledarc ( $im, $centx, $centy, (2*$laenge)-23, (2*$laenge)-23, $Himmelsrichtung[2][0] + 270+$offsetwinkel, $Himmelsrichtung[2][1] +270+$offsetwinkel , $blau , IMG_ARC_EDGED | IMG_ARC_NOFILL);

// Kreis in der Mitte zum "lschen"
imagefilledellipse ( $im, $centx, $centy, $laenge*1.4, $laenge*1.4, $background );

}



// Himmelrichtungen zeichnen
{
for ($i = 0; $i <= 3; $i++) {
$alpha = $i * 90;    

imageline ( $im , $centx , $centy , $laenge - cos (deg2rad($alpha + $offsetwinkel) ) * $laenge , $laenge+$top - sin (deg2rad($alpha + $offsetwinkel) ) * $laenge , $skalafarbe);
}
}

// Zeiger Himmelsrichtung zeichnen
{
$xend = $laenge - cos (deg2rad($winkel + $offsetwinkel) ) * $laenge;
$yend = $laenge+$top - sin (deg2rad($winkel + $offsetwinkel) ) * $laenge;
if ($JetztHoehenwinkel >= 0 )
	{
imagesetthickness ( $im , 3 );
imageline ( $im , $centx , $centy , $xend , $yend , $grau);
	}
imagesetthickness ( $im , 1 );
imageline ( $im , $centx , $centy , $xend , $yend , $zeigerfarbe );
}


// Sonnenhhe auf Quadrat zeichnen
{
// Diagramm-Linien zeichnen
//    Startpunkt: x = $breite *4/5 , y = $hoehe *2/5 , lnge = $breite *4/5 - $breite /3
$startx = $breite *4/5;
$starty = $hoehe *2/5;
$lang = $breite *4/5 - $breite /3;
imagesetthickness ( $im , 1 );
// dunkler Kreisbogen
imagefilledarc ( $im , $startx, $starty, 2*$lang , 2*$lang, 180 , 270 , $schwarz , IMG_ARC_PIE );
// blauer Kreisbogen bis zum Jahreshchstwert
imagefilledarc ( $im , $startx, $starty, 2*$lang , 2*$lang, 180 , 180 + $Hoehenwinkel[0][2] , $dunkelblau , IMG_ARC_PIE );
// gelber Kreisbogen bis Heute Hchstwert
imagefilledarc ( $im , $startx, $starty, 2*$lang , 2*$lang, 180 , 180 + $Hoehenwinkel[1][2] , $gelb , IMG_ARC_PIE );
// Innenbereich lschen
imagefilledarc ( $im , $startx, $starty, $lang *10/6, $lang *10/6, 180 , 270 , $background , IMG_ARC_PIE );
}

 // Winkel fr  Hchst und Tiefststand
{
for ($m = 0 ; $m <= 2 ; $m++ )
	{
$endx = ($startx - cos (deg2rad ($Hoehenwinkel[$m][2] )) * $lang);
$endy = ($starty - sin (deg2rad ($Hoehenwinkel[$m][2] )) * $lang) ;
echo "Hhe: ".$Hoehenwinkel[$m][2]." m: ".$m;
imagesetthickness ( $im , 2 );
imageline ( $im , $startx , $starty , $endx , $endy , $hellblau);
	}
	
// und jetzt nochmal innenbereich lschen fr Skalenstriche
imagefilledarc ( $im , $startx, $starty, round($lang *9/6), round($lang *9/6), 180 , 270 , $background , IMG_ARC_PIE | IMG_ARC_EDGED);

// Diagramm-Rnder
imageline ( $im, $startx, $starty, $breite/3, $starty, $skalafarbe );
imageline ( $im, $startx, $starty, $startx, $starty - $lang, $skalafarbe );

// zum testen
//$JetztHoehenwinkel = 22;
// Winkel fr jetzt
$endx = ($startx - cos (deg2rad ($JetztHoehenwinkel )) * $lang) ;
$endy = ($starty - sin (deg2rad ($JetztHoehenwinkel )) * $lang) ;
// wird nur angezeigt wenn Sonne ber Horizont
if ($JetztHoehenwinkel >= 0 )
	{
imagesetthickness ( $im , 3 );
imageline ( $im , $startx , $starty , $endx , $endy , $grau);
	
imagesetthickness ( $im , 1 );
imageline ( $im , $startx , $starty , $endx , $endy , $zeigerfarbe );
	}
}

// Hhenwinkel wenn Sonne ber dem Horizont, grauer kasten ber Zeiger
if ($JetztHoehenwinkel >= 0 )
	{
	$HWbox = imagettfbbox ( 12 , 0 , $digischrift , $JetztHoehenwinkel ."" );
	imagefilledrectangle ( $im , $startx - $HWbox[2] - 5 , $starty +  $HWbox[5] - 5 , $startx - 2 , $starty - 2, $hellgrau );
	
		imagefilledrectangle ( $im , $startx - $HWbox[2] - 2 , $starty +  $HWbox[5] - 2 , $startx - 3 , $starty - 3, $backgroundalpha );
	imagettftext ( $im, 12, 0, $startx - $HWbox[2]-2, $starty -2, $gruen, $digischrift, $JetztHoehenwinkel."");
	}
	
	// Anzeige von Heute Hchststand (daymax) = $Hoehenwinkel[1][2]
	$daymaxbox = imagettfbbox ( 6 , 0 , $schrift , "max ".$Hoehenwinkel[1][2] ."");
	imagettftext ( $im , 6 , 0 , $startx - $daymaxbox[2]-2 , $hoehe * 1/6 , $blau , $schrift , "max ".$Hoehenwinkel[1][2]."" );
	
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Huschen einzeichnen
{
imagefilledrectangle ( $im , $centx - $breite/8 , $centy - $hoehe/8 , $centx + $breite/8 , $centy + $hoehe/8 , $hellgrau );
}


// Beschriftungen *******************************************************************************************************
{
//imagesetthickness ( $im , 1 );
    // Datum und Zeit
$dat = date ("j.m.Y");
$tim = date ("H:i:s");

imagettftext ( $im, 8, 0, 4, 11, $schwarz, $schrift, $dat );
imagettftext ( $im, 10, 0, 3, 23, $schwarz, $digischrift, $tim );

// SR (Sunrise)
$SRbox = imagettfbbox ( 11 , 0 , $digischrift , substr($value[1][0], 0 , 5) );
imagettftext ( $im, 11, 0, $breite - $SRbox[2]-2, $hoehe -1, $schwarz, $digischrift, substr($value[1][0], 0 , 5) );

$SR2box = imagettfbbox ( 8 , 0 , $schrift , substr($value[1][3], 0 , 5) );
imagettftext ( $im, 8, 0, $breite - $SR2box[2]-2, $hoehe -13, $schwarz, $schrift, substr($value[1][3], 0 , 5) );
// SS (Sunset)
imagettftext ( $im, 11, 0, 1, $hoehe -1, $schwarz, $digischrift, substr($value[1][1], 0 , 5) );
imagettftext ( $im, 8, 0, 1, $hoehe -13, $schwarz, $schrift, substr($value[1][4], 0 , 5) );
}
// HoehenWinkel anzeigen bei Sonne unter 0 Grad
if ($JetztHoehenwinkel < 0 ) imagettftext ( $im, 9, 0, $breite*3/5, $hoehe *3/7+5, $schwarz, $schrift, $JetztHoehenwinkel );

// Nordpfeil
imagettftext ( $im, 12, $offsetwinkel *-1, $centx -3, $centy - $hoehe/8 +3, $blau, $schrift, "N");

// KompassWinkel anzeigen
$Compassbox = imagettfbbox ( 13 , 0 , $digischrift , $JetztHimmelsrichtung ."" );
imagefilledrectangle ( $im , $laenge - 0.5 * ( $Compassbox[2]-$Compassbox[1]) , $centy + 20 + $Compassbox[5]  ,  $laenge + 0.5 * ( $Compassbox[2]-$Compassbox[1]), $centy + 20, $backgroundalpha );
imagettftext ( $im, 13, 0, $laenge - 0.5 * ( $Compassbox[2]-$Compassbox[1]), $centy + 20, $gruen, $digischrift, $JetztHimmelsrichtung ."");
	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Grafik speichern

imagebmp ($im, $file.".bmp");

// ber Server das Bild umschalten (ausschalten)
//include ("Studio.php");
//$objekt = "TestAnalog".substr($file , 2)."Grafik";
//SetStudio ($objekt , "aus");

/*
print_r($value);
print_r($Hoehenwinkel);
print_r($Himmelsrichtung);
echo $JetztHoehenwinkel."\n";
echo $JetztHimmelsrichtung;
*/


// SetStudio ("SunInfo" , "aus");

?>